blob: 163eefc57b5d4c7dfb1fcb923bd15593d0c1dd94 [file] [log] [blame]
Petr Michalec1ed1b3c2017-08-08 19:19:01 +02001#!/bin/bash -e
2
3# bootstrap.sh
4
5# Installs Salt and configure minimal SaltMaster or Minion to be used with:
6# - http://github.com/salt-formulas-scripts
7# - http://github.com/salt-formulas/salt-formula-salt (salt.master sls)
8
9# TODO:
10# - use PPA repository as formula source
11# - support for spm/yum
12
13
14# Source specific env vars.
15# shopt -u dotglob
16export RECLASS_ROOT=${RECLASS_ROOT:-/srv/salt/reclass}
17function source_local_envs() {
Petr Michalecb444ef92017-08-17 13:53:14 +020018 for path in / /tmp/kitchen /srv/salt . ${RECLASS_ROOT}/classes/cluster ${RECLASS_ROOT}/classes/cluster/${CLUSTER_NAME}; do
Vasyl Saienko7a4161c2017-08-14 17:43:15 +030019 for f in $(find $path -maxdepth 1 -name '*.env' 2> /dev/null); do
20 echo "Sourcing env variables from $f"
21 source $f
22 done
23 done
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020024}
25source_local_envs
26
27##########################################
28# Set defaults env variables
29
30if [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
31 set -x
32 SALT_LOG_LEVEL="--state-verbose=true -ldebug"
33fi
34
35export MAGENTA='\033[0;95m'
36export YELLOW='\033[1;33m'
37export BLUE='\033[0;35m'
38export CYAN='\033[0;96m'
39export RED='\033[0;31m'
40export NC='\033[0m' # No Color'
41
42export LC_ALL=C
43export SALT_LOG_LEVEL="--state-verbose=false -lerror"
44export SALT_OPTS="${SALT_OPTS:- --timeout=120 --state-output=changes --retcode-passthrough --force-color $SALT_LOG_LEVEL }"
45export SALT_STATE_RETRY=${SALT_STATE_RETRY:-3}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020046
47
48# salt apt repository
49test -e /etc/lsb-release && eval $(cat /etc/lsb-release)
50which lsb_release && DISTRIB_CODENAME=${DISTRIB_CODENAME:-$(lsb_release -cs)}
51#
Dmitry Ukov95492a02017-10-23 11:34:45 +040052export APT_REPOSITORY=${APT_REPOSITORY:- deb [arch=amd64] http://apt.mirantis.com/${DISTRIB_CODENAME} ${DISTRIB_REVISION:-stable} salt}
chnyda30c07a62017-09-20 14:28:02 +020053export APT_REPOSITORY_GPG=${APT_REPOSITORY_GPG:-http://apt.mirantis.com/public.gpg}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020054
55# reclass
56export RECLASS_ADDRESS=${RECLASS_ADDRESS:-https://github.com/salt-formulas/openstack-salt.git} # https/git
57
58# formula
59export FORMULAS_BASE=${FORMULAS_BASE:-https://github.com/salt-formulas}
60export FORMULAS_PATH=${FORMULAS_PATH:-/usr/share/salt-formulas}
61export FORMULAS_BRANCH=${FORMULAS_BRANCH:-master}
62export FORMULAS_SOURCE=${FORMULAS_SOURCE:-pkg} # pkg/git
63# essential set of formulas (known to by used on cfg01 node for most setups)
Petr Michalece07cd0b2017-11-15 11:41:57 +010064FORMULAS_SALT_MASTER=${FORMULAS_SALT_MASTER:- $EXTRA_FORMULAS}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020065# minimal set of formulas for salt-master bootstrap
66declare -a FORMULAS_SALT_MASTER=(linux reclass salt git $(echo $FORMULAS_SALT_MASTER))
67export FORMULAS_SALT_MASTER
68
69# system / host
Petr Michalecc749e862017-09-06 21:10:10 +020070export HOSTNAME=${HOSTNAME:-`hostname -s`}
71export HOSTNAME=${HOSTNAME//.*/}
72export DOMAIN=${DOMAIN:-`hostname -d`}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020073export DOMAIN=${DOMAIN:-bootstrap.local}
74
75# salt
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020076export MINION_ID=${MINION_ID:-${HOSTNAME}.${DOMAIN}}
Petr Michalec2e3a4992017-08-17 14:20:43 +020077export MASTER_HOSTNAME=${MASTER_HOSTNAME:-${HOSTNAME}.${DOMAIN}}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020078
79# saltstack
Petr Michalec33c04892017-09-08 15:10:30 +020080BOOTSTRAP_SALTSTACK=${BOOTSTRAP_SALTSTACK:-True}
Petr Michalece11cf612017-09-08 18:21:48 +020081BOOTSTRAP_SALTSTACK_VERSION=${BOOTSTRAP_SALTSTACK_VERSION:- stable 2016.3 }
Petr Michalec33c04892017-09-08 15:10:30 +020082BOOTSTRAP_SALTSTACK_OPTS=${BOOTSTRAP_SALTSTACK_OPTS:- -dX $BOOTSTRAP_SALTSTACK_VERSION }
Petr Michalece11cf612017-09-08 18:21:48 +020083SALT_SOURCE=${SALT_SOURCE:-pkg}
84# the version below is used salt pillar data
85SALT_VERSION=${SALT_VERSION:-latest}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020086
87# environment
88if [ "$FORMULAS_SOURCE" == "git" ]; then
89 SALT_ENV=${SALT_ENV:-dev}
90elif [ "$FORMULAS_SOURCE" == "pkg" ]; then
91 SALT_ENV=${SALT_ENV:-prd}
92fi
Petr Michalec05b52452017-09-08 14:26:59 +020093eval "$(grep -h '=' /etc/*release 2> /dev/null)"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +020094PLATFORM_FAMILY=$(echo ${ID_LIKE// */} | tr A-Z a-z)
95case $PLATFORM_FAMILY in
96 debian )
97 PKGTOOL="$SUDO apt-get"
98 test ${VERSION_ID//\.*/} -ge 16 && {
99 SVCTOOL=service
100 } || { SVCTOOL=service
101 }
102 ;;
103 rhel )
104 PKGTOOL="$SUDO yum"
105 test ${VERSION_ID//\.*/} -ge 7 && {
106 SVCTOOL=systemctl
107 } || { SVCTOOL=service
108 }
109 ;;
110esac
111
112export PLATFORM_FAMILY
113export PKGTOOL
114export SVCTOOL
115
116##########################################
117# FUNCTIONS
118
119log_info() {
120 echo -e "${YELLOW}[INFO] $* ${NC}"
121}
122
123log_warn() {
124 echo -e "${MAGENTA}[WARN] $* ${NC}"
125}
126
Petr Michalec24b30e82017-08-21 10:59:18 +0200127log_debug() {
128 echo -e "${CYAN}[WARN] $* ${NC}"
129}
130
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200131log_err() {
132 echo -e "${RED}[ERROR] $* ${NC}" >&2
133}
134
135configure_pkg_repo()
136{
137
138 case $PLATFORM_FAMILY in
139 debian)
140 if [ -n "$APT_REPOSITORY_PPA" ]; then
141 which add-apt-repository || $SUDO apt-get install -y software-properties-common
142 $SUDO add-apt-repository -y ppa:${APT_REPOSITORY_PPA}
143 else
Mykyta Karpinfbcb5482017-10-04 14:15:25 +0300144 echo -e "$APT_REPOSITORY " | $SUDO tee /etc/apt/sources.list.d/mcp_salt.list >/dev/null
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200145 curl -sL $APT_REPOSITORY_GPG | $SUDO apt-key add -
146 fi
147 $SUDO apt-get clean
148 $SUDO apt-get update
149 ;;
150 rhel)
151 $SUDO yum install -y https://repo.saltstack.com/yum/redhat/salt-repo-latest-1.el${VERSION_ID}.noarch.rpm
152 $SUDO yum clean all
153 ;;
154 esac
155
156}
157
158_atexit() {
159 RETVAL=$?
160 trap true INT TERM EXIT
161
162 if [ $RETVAL -ne 0 ]; then
163 log_err "Execution failed"
164 else
165 log_info "Execution successful"
166 fi
167 return $RETVAL
168}
169
170retry() {
171 local tries
172 if [[ $1 =~ ^[0-9]+$ ]]; then
173 tries=$1; shift
174 else
175 tries=3
176 fi
Petr Michalec262e3ad2017-10-06 13:41:58 +0200177 ret=1
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200178 for i in $(seq 1 $tries); do
Petr Michalec262e3ad2017-10-06 13:41:58 +0200179 "$@" && return $? || ret=$?
180 sleep $i
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200181 done
Petr Michalec9fec8b32017-10-05 14:46:42 +0200182 return $ret
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200183}
184
185function clone_reclass() {
Petr Michaleca361d4e2017-09-08 11:38:16 +0200186 if [ ! -d ${RECLASS_ROOT}/classes ]; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200187 # No reclass at all, clone from given address
188 ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true
189 if echo ${RECLASS_BRANCH:-master} | egrep -q "^refs"; then
190 git clone ${RECLASS_ADDRESS} ${RECLASS_ROOT}
191 cd ${RECLASS_ROOT}
192 git fetch ${RECLASS_ADDRESS} ${RECLASS_BRANCH:-master} && git checkout FETCH_HEAD
193 cd -
194 else
195 git clone -b ${RECLASS_BRANCH:-master} ${RECLASS_ADDRESS} ${RECLASS_ROOT};
196 fi;
197 fi;
Petr Michalec679f15b2017-09-18 16:16:29 +0200198 if [ ! -d ${RECLASS_ROOT}/classes ]; then
Petr Michaleca361d4e2017-09-08 11:38:16 +0200199 log_err "Reclass ${RECLASS_ROOT} is not fetched locally;"
200 ls -Rla ${RECLASS_ROOT}
201 exit 1
202 fi;
203 $SUDO mkdir -p $RECLASS_ROOT/classes/service
204 $SUDO mkdir -p $RECLASS_ROOT/nodes/_generated
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200205}
206
207
208##########################################
209# Main calls
210
Petr Michalecda014202017-08-18 11:26:07 +0200211system_config_ssh_conf() {
212 for conf in ~/.ssh/config /root/.ssh/config; do
213 $SUDO mkdir -p $(dirname $conf)
214 if ! grep StrictHostKeyChecking $conf; then
215 # this should be used only in CI environment
216 echo -e "Host *\n\tStrictHostKeyChecking no\n" | $SUDO tee $conf >/dev/null
217 fi
218 done
219 if ! grep github.com ~/.ssh/known_hosts; then
220 ssh-keyscan -H github.com >> ~/.ssh/known_hosts || true
221 fi
222}
223
224system_config_salt_modules_prereq() {
225 # salt-formulas custom modules dependencies, etc:
226 $SUDO $PKGTOOL install -y iproute2 curl sudo apt-transport-https python-psutil python-apt python-m2crypto python-oauth python-pip &>/dev/null
227}
228
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200229system_config_minion() {
230 log_info "System configuration salt minion"
231}
232
233system_config_master() {
234 log_info "System configuration salt master"
235
Petr Michalecda014202017-08-18 11:26:07 +0200236 system_config_salt_modules_prereq
237 system_config_ssh_conf
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200238
Petr Michalecda014202017-08-18 11:26:07 +0200239 if ! grep '127.0.1.2.*salt' /etc/hosts; then
240 echo "127.0.1.2 salt" | $SUDO tee -a /etc/hosts >/dev/null
241 fi
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200242
243 which reclass || $SUDO $PKGTOOL install -y reclass
244
245 which reclass-salt || {
246 test -e /usr/share/reclass/reclass-salt && {
247 ln -fs /usr/share/reclass/reclass-salt /usr/bin
248 }
249 }
250}
251
252configure_salt_master()
253{
254
255 echo "Configuring salt-master ..."
256
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200257 if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then
Petr Michalec29d3ea32017-10-31 17:22:36 +0100258 read -d '' IGNORE_CLASS_NOTFOUND <<-EOF
259 ignore_class_notfound: True
260 ignore_class_regexp:
261 - 'service.*'
262EOF
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200263 fi
264
Petr Michalecdd1a0472017-09-06 19:27:24 +0200265 # to force alternative reclass module path
Petr Michalecd9d0a322017-09-06 19:38:32 +0200266 if [ -n "$RECLASS_SOURCE_PATH" ]; then
267 RECLASS_SOURCE_PATH="reclass_source_path: ${RECLASS_SOURCE_PATH}"
268 else
269 RECLASS_SOURCE_PATH=""
270 fi
Petr Michalecdd1a0472017-09-06 19:27:24 +0200271
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200272 [ ! -d /etc/salt/master.d ] && mkdir -p /etc/salt/master.d
273 cat <<-EOF > /etc/salt/master.d/master.conf
274 file_roots:
275 base:
276 - /usr/share/salt-formulas/env
277 prd:
278 - /srv/salt/env/prd
279 dev:
280 - /srv/salt/env/dev
281 pillar_opts: False
282 open_mode: True
283 reclass: &reclass
284 storage_type: yaml_fs
285 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec4be5e5b2017-08-17 11:44:49 +0200286 ${IGNORE_CLASS_NOTFOUND}
Petr Michalecdd1a0472017-09-06 19:27:24 +0200287 ${RECLASS_SOURCE_PATH}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200288 ext_pillar:
289 - reclass: *reclass
290 master_tops:
291 reclass: *reclass
292EOF
293
294 echo "Configuring reclass ..."
295
296 [ ! -d /etc/reclass ] && mkdir /etc/reclass
297 cat <<-EOF > /etc/reclass/reclass-config.yml
298 storage_type: yaml_fs
299 pretty_print: True
300 output: yaml
301 inventory_base_uri: ${RECLASS_ROOT}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200302EOF
303
304 clone_reclass
305 # override some envs from cluster level *.env, use with care
306 source_local_envs
307
308 cd ${RECLASS_ROOT}
309 if [ ! -d ${RECLASS_ROOT}/classes/system/linux ]; then
310 # Possibly subrepo checkout needed
311 git submodule update --init --recursive
312 fi
313
Petr Michalec212cc6a2017-08-17 21:39:40 +0200314 mkdir -vp ${RECLASS_ROOT}/nodes/_generated
Petr Michalec51ece842017-09-06 20:44:15 +0200315 rm -rvf ${RECLASS_ROOT}/nodes/_generated/*
316
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200317 CONFIG=$(find ${RECLASS_ROOT}/nodes -name ${MINION_ID}.yml| grep yml | tail -n1)
Petr Michalec212cc6a2017-08-17 21:39:40 +0200318 CONFIG=${CONFIG:-${RECLASS_ROOT}/nodes/_generated/${MINION_ID}.yml}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200319 if [[ $SALT_MASTER_BOOTSTRAP_MINIMIZED =~ ^(True|true|1|yes)$ || ! -f "${CONFIG}" ]]; then
Petr Michalec24b30e82017-08-21 10:59:18 +0200320 log_warn "Salt Master node specification has not been found in model."
321 log_warn "Creating temporary cfg01 configuration for bootstrap: ${CONFIG}"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200322 cat <<-EOF > ${CONFIG}
323 classes:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200324 - cluster.${CLUSTER_NAME}.infra.config
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200325 parameters:
326 _param:
Petr Michaleca7de6df2017-08-31 12:16:57 +0200327 salt_master_host: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200328 salt_master_base_environment: $SALT_ENV
Petr Michalecd81d1f52017-08-17 20:18:06 +0200329 salt_formula_branch: ${SALT_FORMULAS_BRANCH:-master}
330 reclass_data_revision: ${RECLASS_BRANCH:-master}
331 reclass_data_repository: "$RECLASS_ADDRESS"
Petr Michaleca7de6df2017-08-31 12:16:57 +0200332 reclass_config_master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalecd81d1f52017-08-17 20:18:06 +0200333 linux_system_codename: ${DISTRIB_CODENAME}
334 cluster_name: ${CLUSTER_NAME}
335 cluster_domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200336 linux:
337 system:
Petr Michalecd81d1f52017-08-17 20:18:06 +0200338 name: ${HOSTNAME:-cfg01}
339 domain: ${DOMAIN:-$CLUSTER_NAME.local}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200340 # ########
341EOF
342
343 if [ "$SALT_VERSION" == "latest" ]; then
344 VERSION=""
345 else
346 VERSION="version: $SALT_VERSION"
347 fi
348
349 cat <<-EOF >> ${CONFIG}
350 salt:
351 master:
352 accept_policy: open_mode
353 source:
354 engine: $SALT_SOURCE
355 $VERSION
356 minion:
357 source:
358 engine: $SALT_SOURCE
359 $VERSION
360 # ########
361 # vim: ft=yaml sw=2 ts=2 sts=2
362EOF
363 fi
Petr Michalec24b30e82017-08-21 10:59:18 +0200364
365 log_debug "Salt Master node config yaml:"
366 log_debug "$(cat ${CONFIG})"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200367}
368
369configure_salt_minion()
370{
371 [ ! -d /etc/salt/minion.d ] && mkdir -p /etc/salt/minion.d
372 cat <<-EOF > /etc/salt/minion.d/minion.conf
Petr Michaleca7de6df2017-08-31 12:16:57 +0200373 master: ${MASTER_IP:-$MASTER_HOSTNAME}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200374 id: $MINION_ID
375 EOF
376}
377
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200378install_reclass()
379{
380 VERSION=${1:-$RECLASS_VERSION}
Petr Michalec372fa032017-11-15 17:36:19 +0100381 VERSION=${VERSION:-pkg}
Petr Michalec800dd072017-11-15 17:19:26 +0100382 case ${VERSION} in
383 pkg|package)
384 which reclass || $SUDO $PKGTOOL install -y reclass
385 ;;
386 *)
Petr Michalec981f3cc2017-11-15 17:40:31 +0100387 log_warn "Install development version of reclass"
Petr Michalec800dd072017-11-15 17:19:26 +0100388 # For dev/git/pip version...
389 # Note: It replaces all local reclass versions on system
390 for s in $(python -c "import site; print(' '.join(site.getsitepackages()))"); do
Petr Michalec23020832017-11-15 17:34:49 +0100391 sudo -H pip install --install-option="--prefix=" --upgrade --force-reinstall -I \
Petr Michalec800dd072017-11-15 17:19:26 +0100392 -t "$s" git+https://github.com/salt-formulas/reclass.git@${VERSION};
393 done
394 ;;
395 esac
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200396}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200397
398install_salt_master_pkg()
399{
400 echo -e "\nPreparing base OS repository ...\n"
401
402 configure_pkg_repo
403
404 echo -e "\nInstalling salt master ...\n"
405
406 case $PLATFORM_FAMILY in
407 debian)
408 $SUDO apt-get install -y git
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200409 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
410 ;;
411 rhel)
412 yum install -y git
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200413 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- -M ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
414 ;;
415 esac
416
417 which reclass-salt || {
418 test -e /usr/share/reclass/reclass-salt && {
419 ln -fs /usr/share/reclass/reclass-salt /usr/bin
420 }
421 }
422
423 configure_salt_master
424
425 echo -e "\nRestarting services ...\n"
426 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
427 $SVCTOOL salt-master restart
428}
429
430install_salt_master_pip()
431{
432 echo -e "\nPreparing base OS repository ...\n"
433
434 case $PLATFORM_FAMILY in
435 debian)
436 $SUDO apt-get install -y python-pip python-dev zlib1g-dev git
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200437 ;;
438 rhel)
439 $SUDO yum install -y git
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200440 ;;
441 esac
442
443 echo -e "\nInstalling salt master ...\n"
444 # TODO: replace with saltstack bootstrap script
445
446 if [ "$SALT_VERSION" == "latest" ]; then
447 pip install salt
448 else
449 pip install salt==$SALT_VERSION
450 fi
451
452 curl -Lo /etc/init.d/salt-master https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-master.init && chmod 755 /etc/init.d/salt-master
453 ln -s /usr/local/bin/salt-master /usr/bin/salt-master
454
455 which reclass-salt || {
456 test -e /usr/share/reclass/reclass-salt && {
457 ln -fs /usr/share/reclass/reclass-salt /usr/bin
458 }
459 }
460
461 configure_salt_master
462
463 echo -e "\nRestarting services ...\n"
464 [ -f /etc/salt/pki/minion/minion_master.pub ] && rm -f /etc/salt/pki/minion/minion_master.pub
465 $SVCTOOL salt-master restart
466}
467
468
469
470install_salt_minion_pkg()
471{
472
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200473 echo -e "\nInstalling salt minion ...\n"
474
475 case $PLATFORM_FAMILY in
476 debian)
477 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
478 ;;
479 rhel)
480 curl -L https://bootstrap.saltstack.com | $SUDO sh -s -- ${BOOTSTRAP_SALTSTACK_OPTS} &>/dev/null || true
481 ;;
482 esac
483
484
485 configure_salt_minion
Petr Michalec3b7fdd82017-09-08 15:35:56 +0200486 #$SVCTOOL salt-minion restart
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200487}
488
489install_salt_minion_pip()
490{
491 echo -e "\nInstalling salt minion ...\n"
492
493 curl -Lo /etc/init.d/salt-minion https://anonscm.debian.org/cgit/pkg-salt/salt.git/plain/debian/salt-minion.init && chmod 755 /etc/init.d/salt-minion
494 ln -s /usr/local/bin/salt-minion /usr/bin/salt-minion
495
496 configure_salt_minion
Petr Michalec3b7fdd82017-09-08 15:35:56 +0200497 #$SVCTOOL salt-minion restart
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200498}
499
500
501install_salt_formula_pkg()
502{
503 configure_pkg_repo
504
505 case $PLATFORM_FAMILY in
506 debian)
507 echo "Configuring necessary formulas ..."
508
509 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
510 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
511 [ -z ${FORMULAS_SALT_MASTER+x} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
512 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
513 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
514 [ ! -d "${FORMULAS_PATH}/env/${formula_service}" ] && \
515 if ! $SUDO apt-get install -y salt-formula-${formula_service}; then
516 echo -e "\nInstall salt-formula-${formula_service} failed.\n"
517 exit 1
518 fi
519 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
520 ln -sf ${FORMULAS_PATH}/reclass/service/${formula_service} ${RECLASS_ROOT}/classes/service/${formula_service}
521 done
522 ;;
523 rhel)
524 # TODO
525 ;;
526 esac
527
528 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
529 [ ! -L /srv/salt/env/prd ] && ln -s ${FORMULAS_PATH}/env /srv/salt/env/prd || echo ""
530}
531
532install_salt_formula_git()
533{
534 echo "Configuring necessary formulas ..."
535
536 [ ! -d ${RECLASS_ROOT}/classes/service ] && mkdir -p ${RECLASS_ROOT}/classes/service
537 # Set essentials if FORMULAS_SALT_MASTER is not defined at all
538 [ -z ${FORMULAS_SALT_MASTER+x} ] && declare -a FORMULAS_SALT_MASTER=("linux" "reclass" "salt" "memcached")
539 for formula_service in "${FORMULAS_SALT_MASTER[@]}"; do
540 echo -e "\nConfiguring salt formula ${formula_service} ...\n"
541 _BRANCH=${FORMULAS_BRANCH}
542 [ ! -d "${FORMULAS_PATH}/env/_formulas/${formula_service}" ] && {
543 if ! git ls-remote --exit-code --heads ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${_BRANCH}; then
544 # Fallback to the master branch if the branch doesn't exist for this repository
545 _BRANCH=master
546 fi
547 if ! git clone ${FORMULAS_BASE}/salt-formula-${formula_service}.git ${FORMULAS_PATH}/env/_formulas/${formula_service} -b ${_BRANCH}; then
548 echo -e "\nCloning of ${FORMULAS_BASE}/salt-formula-${formula_service}.git failed.\n"
549 exit 1
550 fi
551 } || {
552 cd ${FORMULAS_PATH}/env/_formulas/${formula_service};
553 git fetch origin/${_BRANCH} || git fetch --all
554 git checkout ${_BRANCH} && git pull || git pull;
555 cd -
556 }
557 [ ! -L "/usr/share/salt-formulas/env/${formula_service}" ] && \
558 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/${formula_service} /usr/share/salt-formulas/env/${formula_service}
559 [ ! -L "${RECLASS_ROOT}/classes/service/${formula_service}" ] && \
560 ln -sf ${FORMULAS_PATH}/env/_formulas/${formula_service}/metadata/service ${RECLASS_ROOT}/classes/service/${formula_service}
561 done
562
563 [ ! -d /srv/salt/env ] && mkdir -p /srv/salt/env || echo ""
564 [ ! -L /srv/salt/env/dev ] && ln -s /usr/share/salt-formulas/env /srv/salt/env/dev || echo ""
565}
566
567
568saltmaster_bootstrap() {
569
570 log_info "Salt master setup"
571 test -n "$MASTER_HOSTNAME" || exit 1
572
573 clone_reclass
574 # override some envs from cluster level *.env, use with care
575 source_local_envs
576
Petr Michalec7ed7d8f2017-10-10 15:38:29 +0200577 pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {} || true
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200578 pkill -9 salt-minion
projoke3c30e7d2017-10-19 17:15:40 +0800579 SCRIPTS=$(dirname $0)
580
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200581 test -e ${SCRIPTS}/.salt-master-setup.sh.passed || {
Adam Tengler035f24f2017-09-11 19:29:31 +0200582 export MASTER_IP=${MASTER_IP:-127.0.0.1}
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200583 export MINION_ID=${MASTER_HOSTNAME}
584 if ! [[ $DEBUG =~ ^(True|true|1|yes)$ ]]; then
585 SALT_MASTER_SETUP_OUTPUT='/dev/stdout'
586 fi
587 # call local "setup() master"
588 #if ! $SUDO ${SCRIPTS}/salt-master-setup.sh master &> ${SALT_MASTER_SETUP_OUTPUT:-/tmp/salt-master-setup.log}; then
589 if ! setup master; then
590 #cat /tmp/salt-master-setup.log
591 log_err "salt master setup() failed."
592 exit 1
593 else
594 $SUDO touch ${SCRIPTS}/.salt-master-setup.sh.passed
595 fi
596 }
597
Petr Michalec981f3cc2017-11-15 17:40:31 +0100598 log_info "Install reclass"
599 install_reclass ${RECLASS_VERSION/dev*/develop}
Petr Michaleca6cd2bd2017-09-07 16:59:19 +0200600
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200601 log_info "Re/starting salt services"
Petr Michalec7ed7d8f2017-10-10 15:38:29 +0200602 $SUDO service salt-minion stop
603 $SUDO service salt-master stop
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200604 sleep 10
Petr Michalec7ed7d8f2017-10-10 15:38:29 +0200605 pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {} || true
606 pkill -9 salt-minion
607 $SUDO service salt-master start
608 $SUDO service salt-minion start
609 sleep 15
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200610}
611
612# Init salt master
613saltmaster_init() {
614
615 log_info "Runing saltmaster states"
616 test -n "$MASTER_HOSTNAME" || exit 1
617
618 set -e
619 $SUDO salt-call saltutil.sync_all >/dev/null
620
621 # TODO: Placeholder update saltmaster spec (nodes/FQDN.yml) to be able to bootstrap with minimal configuration
622 # (ie: with linux, git, salt formulas)
623
624 #log_info "Verify SaltMaster, before salt-master is fully initialized"
625 #if ! $SUDO reclass-salt -p ${MASTER_HOSTNAME} &> /tmp/${MASTER_HOSTNAME}.pillar;then
626 # log_warn "Node verification before initialization failed."; cat /tmp/${MASTER_HOSTNAME}.pillar;
627 #fi
628
Petr Michalecda014202017-08-18 11:26:07 +0200629 # workarond isolated and not fully bootstraped environments
Petr Michalec2801acb2017-10-31 15:00:15 +0100630 if [[ $RECLASS_IGNORE_CLASS_NOTFOUND =~ ^(True|true|1|yes)$ ]]; then
Petr Michalec64adbd72017-10-31 15:26:41 +0100631 SALT_MASTER_PILLAR='"salt":{"master":{"pillar":{"reclass":{"ignore_class_notfound": "'${RECLASS_IGNORE_CLASS_NOTFOUND:-False}'", "ignore_class_regexp": ["service.*"]}}}},'
Petr Michalec2801acb2017-10-31 15:00:15 +0100632 fi
Petr Michalec64adbd72017-10-31 15:26:41 +0100633 PILLAR='{'${SALT_MASTER_PILLAR}' "reclass":{"storage":{"data_source":{"engine":"local"}}} }'
Petr Michalecda014202017-08-18 11:26:07 +0200634
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200635 log_info "State: salt.master.env"
Petr Michalecda014202017-08-18 11:26:07 +0200636 if ! $SUDO salt-call ${SALT_OPTS} -linfo state.apply salt.master.env pillar="$PILLAR"; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200637 log_err "State salt.master.env failed, keep your eyes wide open."
638 fi
639
640 log_info "State: salt.master.pillar"
Petr Michalecda014202017-08-18 11:26:07 +0200641 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.pillar pillar="$PILLAR"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200642 # Note: sikp reclass data dir states
643 # in order to avoid pull from configured repo/branch
644
645 # Revert temporary SaltMaster minimal configuration, if any
646 pushd $RECLASS_ROOT
647 if [ $(git diff --name-only nodes | sort | uniq | wc -l) -ge 1 ]; then
Petr Michalec87778fc2017-11-02 10:13:25 +0100648 PILLAR='{"reclass":{"storage":{"data_source":{"engine":"local"}}} }'
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200649 git status || true
Petr Michalecda014202017-08-18 11:26:07 +0200650 log_warn "Locally modified $RECLASS_ROOT/nodes found. (Possibly salt-master minimized setup from bootstrap.sh call)"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200651 log_info "Checkout HEAD state of $RECLASS_ROOT/nodes/*."
652 git checkout -- $RECLASS_ROOT/nodes || true
653 log_info "Re-Run states: salt.master.env and salt.master.pillar according the HEAD state."
654 log_info "State: salt.master.env"
Petr Michalecda014202017-08-18 11:26:07 +0200655 if ! $SUDO salt-call ${SALT_OPTS} -linfo state.apply salt.master.env pillar="$PILLAR"; then
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200656 log_err "State salt.master.env failed, keep your eyes wide open."
657 fi
658 log_info "State: salt.master.pillar"
Petr Michalecda014202017-08-18 11:26:07 +0200659 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.pillar pillar="$PILLAR"
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200660 fi
661 popd
662
Petr Michalecda014202017-08-18 11:26:07 +0200663 # finally re-configure salt master conf, ie: may remove ignore_class_notfound option
664 log_info "State: salt.master.service"
Petr Michalec9fec8b32017-10-05 14:46:42 +0200665 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply salt.master.service || true
Petr Michalecda014202017-08-18 11:26:07 +0200666
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200667 log_info "State: salt.master.storage.node"
668 set +e
Petr Michaleca5141342017-08-16 12:55:20 +0200669 # TODO: PLACEHOLDER TO TRIGGER NODE GENERATION THROUG SALT REACT.
Petr Michalec9fec8b32017-10-05 14:46:42 +0200670 retry ${SALT_STATE_RETRY} $SUDO salt-call ${SALT_OPTS} state.apply reclass.storage.node
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200671 ret=$?
672 set -e
673
674 if [[ $ret -eq 2 ]]; then
675 log_err "State reclass.storage.node failed with exit code 2 but continuing."
676 elif [[ $ret -ne 0 ]]; then
677 log_err "State reclass.storage.node failed with exit code $ret"
678 exit 1
679 fi
680
681 log_info "Re/starting salt services"
682 $SUDO sed -i 's/^master:.*/master: localhost/' /etc/salt/minion.d/minion.conf
Petr Michalecc0bfa972017-09-08 15:21:01 +0200683 $SUDO service salt-minion stop
684 $SUDO service salt-master stop
Petr Michalec7ed7d8f2017-10-10 15:38:29 +0200685 sleep 10
686 pgrep salt-master | sed /$$/d | xargs --no-run-if-empty -i{} $SUDO kill -9 {} || true
Petr Michalecc0bfa972017-09-08 15:21:01 +0200687 $SUDO service salt-master start
688 $SUDO service salt-minion start
Petr Michalec7ed7d8f2017-10-10 15:38:29 +0200689 sleep 15
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200690 $SUDO salt-call ${SALT_OPTS} saltutil.sync_all >/dev/null
691
692 verify_salt_master
693 set +e
694
695}
696
697
698function verify_salt_master() {
699 set -e
700
701 log_info "Verify Salt master"
702 test -n "$MASTER_HOSTNAME" || exit 1
703
704 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
Petr Michaleca5141342017-08-16 12:55:20 +0200705 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_yaml > /tmp/${MASTER_HOSTNAME}.reclass.validate_yaml
706 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} reclass.validate_pillar > /tmp/${MASTER_HOSTNAME}.reclass.validate_pillar
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200707 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} grains.item roles > /tmp/${MASTER_HOSTNAME}.grains.item.roles
708 $SUDO salt-call ${SALT_OPTS} --id=${MASTER_HOSTNAME} state.show_lowstate > /tmp/${MASTER_HOSTNAME}.state.show_state
709 $SUDO salt-call --no-color grains.items
710 $SUDO salt-call --no-color pillar.data
711 fi
Petr Michaleca5141342017-08-16 12:55:20 +0200712 # TODO: REMOVE reclass --nodeinfo section / run only on debug - as the only required is reclass.validate_*
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200713 if ! $SUDO reclass --nodeinfo ${MASTER_HOSTNAME} > /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo; then
714 log_err "For more details see full log /tmp/${MASTER_HOSTNAME}.reclass.nodeinfo"
715 exit 1
716 fi
717}
718
719function verify_salt_minion() {
720 set -e
721 node=$1
722 log_info "Verifying ${node}"
723 if [[ $VERIFY_SALT_CALL =~ ^(True|true|1|yes)$ ]]; then
724 $SUDO salt-call ${SALT_OPTS} --id=${node} grains.item roles > /tmp/${node}.grains.item.roles
725 $SUDO salt-call ${SALT_OPTS} --id=${node} state.show_lowstate > /tmp/${node}.state.show_lowstate
726 fi
727 if ! $SUDO reclass --nodeinfo ${node} > /tmp/${node}.reclass.nodeinfo; then
728 log_err "For more details see full log /tmp/${node}.reclass.nodeinfo"
729 if [[ ${BREAK_ON_VERIFICATION_ERROR:-yes} =~ ^(True|true|1|yes)$ ]]; then
730 exit 1
731 fi
732 fi
733}
734
735function verify_salt_minions() {
736 #set -e
Petr Michalec679f15b2017-09-18 16:16:29 +0200737 NODES=$(find $RECLASS_ROOT/nodes/_generated/ -name "*.yml" | grep -v "cfg")
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200738 log_info "Verifying minions: $(echo ${NODES}|xargs)"
739
740 # Parallel
741 #echo $NODES | parallel --no-notice -j 2 --halt 2 "verify_salt_minion \$(basename {} .yml) > {}.pillar_verify"
742 #ls -lrta *.pillar_verify | tail -n 1 | xargs -n1 tail -n30
743
744 function filterFails() {
745 grep -v '/grains' | tee -a $1 | tail -n20
746 }
747
748 log_info "Verify nodes"
749 passed=0
750 for node in ${NODES}; do
751 node=$(basename $node .yml)
752
753 # filter first in cluster.. ctl-01, mon-01, etc..
754 if [[ "${node//.*}" =~ 01 || "${node//.*}" =~ 02 ]] ;then
755 verify_salt_minion ${node} || continue
756 else
757 echo Skipped $node.
758 fi
759 passed=$(($passed+1))
760 done
761 # fail on failures
762 total=$(echo $NODES | xargs --no-run-if-empty -n1 echo |wc -l)
763 test ! $passed -lt $total || log_err "Results: $passed of $total passed."
764 test ! $passed -lt $total || {
765 tail -n50 /tmp/*.pillar_verify
766 return 1
767 }
768}
769
770
771
772##########################################
773# To install salt master/minon
774
775function install() {
776 setup $@
777}
778
779function setup() {
780 # CLI
781 while [ x"$1" != x"" ]; do
782 which curl &>/dev/null || $PKGTOOL -y install curl &>/dev/null
783
784 case $1 in
785 master )
786 install_salt_master_$SALT_SOURCE
787 install_salt_minion_$SALT_SOURCE
788 install_salt_formula_$FORMULAS_SOURCE
789 ;;
790 minion )
791 install_salt_minion_$SALT_SOURCE
792 ;;
793 esac
794 shift
795 done
796 echo DONE
797}
798
799function bootstrap() {
800 log_info "Bootstrap & verification of SaltMaster and configured minions."
801 trap _atexit INT TERM EXIT
802
803 system_config_master
804 saltmaster_bootstrap &&\
Petr Michalec58575b92017-08-20 10:42:25 +0200805 saltmaster_init #&&\
Petr Michaleca5141342017-08-16 12:55:20 +0200806 #verify_salt_minions
Petr Michalec1ed1b3c2017-08-08 19:19:01 +0200807}
808
809function default() {
810 bootstrap $@
811}
812
813
814##########################################
815[[ "$0" != "$BASH_SOURCE" ]] || {
816# unless file is being sourced
817 default $@
818}